//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// Unmanaged.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "Unmanaged.h"
#include "stdio.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}
UNMANAGED_API void StringCallback(LPWSTR *stringArray, int stringCount, void (__stdcall* function)(int, LPWSTR))
{
	for(int i = 0; i<stringCount;i++)
	{
		function(i, stringArray[i]);
	}
}
UNMANAGED_API void IntegerCallback(int * ia, int intCount, void (__stdcall* function)(int, int))
{
	for(int i = 0; i<intCount;i++)
	{
		function(i, ia[i]);
	}
}
UNMANAGED_API void FloatCallback(float * fa, int floatCount, void (__stdcall* function)(int, float))
{
	for(int i = 0; i<floatCount;i++)
	{
		function(i, fa[i]);
	}
}
UNMANAGED_API void DoubleCallback(double * da, int doubleCount, void (__stdcall* function)(int, double))
{
	for(int i = 0; i<doubleCount;i++)
	{
		function(i, da[i]);
	}
}
