//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>
#include <tchar.h>
#include "unmanaged.h"

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Text;

int _tmain(void)
{
	int retInt = AddInteger(1, 2);
	Console::WriteLine(S"AddInteger after: {0}", __box(retInt));

	String *str = S"This is a test";
	IntPtr sPtr = Marshal::StringToHGlobalAnsi(str);
	int retLength = StringLength((char*)sPtr.ToPointer());
	Console::WriteLine(S"String length: {0}", __box(retLength));
	Marshal::FreeHGlobal(sPtr);

	sPtr = Marshal::StringToHGlobalUni(str);
	retLength = UnicodeStringLength((wchar_t*)sPtr.ToPointer());
	Console::WriteLine(S"Unicode string length: {0}", __box(retLength));
	Marshal::FreeHGlobal(sPtr);

	unsigned char byteRet = ByteFunc(10);
	short shortRet = ShortFunc(10);
	unsigned short ushortRet = WordFunc(10);
	unsigned int uintRet = UintFunc(10);
	int intRet = IntFunc(10);
	long longRet = LongFunc(10);
	unsigned long ulongRet = UnsignedLongFunc(10);
	char charRet = CharFunc(10);
	float floatRet = FloatFunc(10);
	double doubleRet = DoubleFunc(10);

	ByteOutOutFunc(20,&byteRet);
	ShortOutFunc(20, &shortRet);
	WordOutFunc(20, &ushortRet);
	IntOutFunc(20, &intRet);
	UintOutFunc(20, &uintRet);
	LongOutFunc(20, &longRet);
	UnsignedLongOutFunc(20, &ulongRet);
	CharOutFunc(20, &charRet);
	FloatOutFunc(20, &floatRet);
	DoubleOutFunc(20, &doubleRet);

	String *a = S"This is ";
	String *b = S"a test";
	IntPtr aPtr = Marshal::StringToHGlobalAnsi(a);
	IntPtr bPtr = Marshal::StringToHGlobalAnsi(b);
	String *result = ConcatString((char*)aPtr.ToPointer(),
		                          (char*)bPtr.ToPointer());
	Console::WriteLine(S"After String Concat: {0}", result);
	Marshal::FreeHGlobal(aPtr);
	Marshal::FreeHGlobal(bPtr);

	aPtr = Marshal::StringToHGlobalUni(a);
	bPtr = Marshal::StringToHGlobalUni(b);
	result = ConcatUnicodeString((wchar_t*)aPtr.ToPointer(),
		                         (wchar_t*)bPtr.ToPointer());
	Console::WriteLine(S"After Unicode String Concat: {0}", result);
	Marshal::FreeHGlobal(aPtr);
	Marshal::FreeHGlobal(bPtr);

	aPtr = Marshal::StringToHGlobalAnsi(a);
	bPtr = Marshal::StringToHGlobalAnsi(b);
	StringBuilder *sb = new StringBuilder(128);
	IntPtr rPtr = Marshal::StringToHGlobalAnsi(sb->ToString());
	ConcatOutString((char*)aPtr.ToPointer(),
		            (char*)bPtr.ToPointer(),
					(char*)rPtr.ToPointer());
	Console::WriteLine(S"After String Out Concat: {0}", Marshal::PtrToStringAnsi(rPtr));
	Marshal::FreeHGlobal(aPtr);
	Marshal::FreeHGlobal(bPtr);

	int *ia = new int [4];
	ia[0] = 1;
	ia[1] = 2;
	ia[2] = 3;
	ia[3] = 4;
	Console::WriteLine("Int array before: {0}", __box(4));
	retInt = IntArrayFunction(ia, 4);
	Console::WriteLine("Largest integer: {0}", __box(retInt));

	complex ac;
	ac.re = 1.0;
	ac.im = 2.0;
	complex bc;
	bc.re = 3.0;
	bc.im = 4.0;
	complex cc = ComplexAdd(ac, bc);

    return 0;
}