//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the UNMANAGED_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// UNMANAGED_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef UNMANAGED_EXPORTS
#define UNMANAGED_API __declspec(dllexport)
#else
#define UNMANAGED_API __declspec(dllimport)
#endif

extern "C"
{

typedef struct _StructStringRef
{
	wchar_t *a;
	char *b;
} StructStringRef;

typedef struct _TestStruct
{
    unsigned char a;
    short b;
    int c;
    unsigned char d;
    short e;
    int f;
} TestStruct;

typedef struct _complex
{
	float re;
	float im;
} complex;
UNMANAGED_API int AddInteger(int a, int b);

UNMANAGED_API unsigned char ByteFunc(unsigned char a);
UNMANAGED_API short ShortFunc(short a);
UNMANAGED_API unsigned short WordFunc(unsigned short a);
UNMANAGED_API int IntFunc(int a);
UNMANAGED_API unsigned int UintFunc(unsigned int a);
UNMANAGED_API long LongFunc(long a);
UNMANAGED_API unsigned long UnsignedLongFunc(unsigned long a);
UNMANAGED_API char CharFunc(char a);
UNMANAGED_API float FloatFunc(float a);
UNMANAGED_API double DoubleFunc(double a);

UNMANAGED_API void ByteOutOutFunc(unsigned char a, unsigned char* o);
UNMANAGED_API void ShortOutFunc(short a, short *o);
UNMANAGED_API void WordOutFunc(unsigned short a, unsigned short *o);
UNMANAGED_API void UintOutFunc(unsigned int a, unsigned int *o);
UNMANAGED_API void IntOutFunc(int a, int *o);
UNMANAGED_API void LongOutFunc(long a, long *o);
UNMANAGED_API void UnsignedLongOutFunc(unsigned long a, unsigned long *o);
UNMANAGED_API void CharOutFunc(char a, char *o);
UNMANAGED_API void FloatOutFunc(float a, float *o);
UNMANAGED_API void DoubleOutFunc(double a, double *o);

UNMANAGED_API int StringLength(char * str);
UNMANAGED_API int UnicodeStringLength(wchar_t * str);
UNMANAGED_API char * ConcatString(char *a, char *b);
UNMANAGED_API wchar_t * ConcatUnicodeString(wchar_t *a, wchar_t *b);

UNMANAGED_API void ConcatOutString(char* a, char* b, char * o);
UNMANAGED_API void TestStructStringRef(StructStringRef a);

UNMANAGED_API void TestStructFunction(TestStruct *s);
UNMANAGED_API complex ComplexAdd(complex a, complex b);

UNMANAGED_API int IntArrayFunction(int *pia, int length);
UNMANAGED_API float FloatArrayFunction(float *pfa, int length);
UNMANAGED_API int StringArrayFunction(char **psa, int length);

UNMANAGED_API void MatrixMultiplyFunction(int *a, int *b, int *c, int x, int y, int z);
UNMANAGED_API complex ComplexAverage(complex* a, int length);

};
